package ring.world;

import java.util.*;

/**
 * Represents an event generated by the world ticker.
 * @author projectmoon
 *
 */
public class TickerEvent extends EventObject {
	public enum TickerType {
		PULSE
	}

	private static final long serialVersionUID = 1L;
	
	private int currentTick;
	private TickerType type;

	public TickerEvent(Object source, int currentTick, TickerType type) {
		super(source);
		this.currentTick = currentTick;
		this.type = type;
	}

	public int getCurrentTick() {
		return currentTick;
	}

	public TickerType getTickType() {
		return type;
	}
}